uniform sampler2D Texture0;
uniform int ActiveLights;

varying vec3 v;
varying vec3 normal;


void main(void) {
  vec3 Eye       = normalize(-v);
  vec3 Reflected; 
  vec3 lightDir;
  
  vec4 IAmbient  = vec4(0.0,0.0,0.0,0.0);
  vec4 IDiffuse  = vec4(0.0,0.0,0.0,0.0);
  vec4 ISpecular = vec4(0.0,0.0,0.0,0.0);
  
  
  float dist;
  float attenFactor;
  int ActiveLights = 1; 
  
  for (int i=0; i<ActiveLights; ++i)
  {
	dist	= distance(gl_LightSource[i].position.xyz, v);
	attenFactor	= 1.0/(	gl_LightSource[i].constantAttenuation + 
				gl_LightSource[i].linearAttenuation * dist +
				gl_LightSource[i].quadraticAttenuation * dist * dist );
	lightDir  = normalize(gl_LightSource[i].position.xyz - v);	
	Reflected = normalize(reflect( -lightDir, normal)); 
	IAmbient  += gl_LightSource[i].ambient * gl_FrontMaterial.ambient*attenFactor;
	IDiffuse  += gl_LightSource[i].diffuse * max(dot(normal, lightDir), 0.0) * gl_FrontMaterial.diffuse *attenFactor;
	ISpecular += gl_LightSource[i].specular * pow(max(dot(Reflected, Eye), 0.0), gl_FrontMaterial.shininess) * gl_FrontMaterial.specular*attenFactor;

 }
  
  gl_FragColor   = vec4((gl_FrontLightModelProduct.sceneColor + IAmbient + IDiffuse) * texture2D(Texture0, vec2(gl_TexCoord[0])) + ISpecular);
}